### Function

# EDataServer OAuth2ServiceRefSourceFunc

since: 3.28

#### Declaration

    ESource*
    (* EOAuth2ServiceRefSourceFunc) (
      gpointer user_data,
      const gchar* uid
    )

#### Description

No description available.

Available since: 3.28

#### Parameters

`user_data`

  Type: `gpointer`

  User data, as passed to `e_oauth2_service_get_access_token_sync()` or e_oauth2_service_receive_and_store_token_sync(), or e_oauth2_service_refresh_and_store_token_sync().

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`uid`

  Type: `const gchar*`

  An `ESource` UID to return.

  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

#### Return value

Type: `ESource`

An `ESource` with UID `uid`, or `NULL`, if not found. Dereference the returned non-NULL `ESource` with g_object_unref(), when no longer needed.

The caller of the function takes ownership of the data, and is responsible for freeing it.
The return value can be `NULL`.